#! /usr/bin/env python 
import numpy as np 
with open('sqscell.out') as f1: 
    lines = f1.readlines()
 
with open('old-sqscell.out', 'w') as f2:
    for x in lines: f2.write(x) 

with open('sqscell.out', 'w') as f3: 
    tot = int(lines[0].split()[0])  # total number of cells 
    count = 0 
    arr1 = np.zeros((tot, 2)) 
    for i in range(tot): 
        arr1[i][0] = i 
        a1, a2, a3 = [ float(x) for x in lines[4*i+2].split() ] 
        b1, b2, b3 = [ float(x) for x in lines[4*i+3].split() ] 
        c1, c2, c3 = [ float(x) for x in lines[4*i+4].split() ] 
        l1 = (a1**2 + a2**2 + a3**2)**.5 
        l2 = (b1**2 + b2**2 + b3**2)**.5 
        l3 = (c1**2 + c2**2 + c3**2)**.5 
        if l1 == l2 and l2 == l3: 
             arr1[i][1] = l1 
             count += 1 
    arr1 = arr1[arr1[:,1].argsort()] 
    if count >= 3: 
        j = 0 
        f3.write('3\n\n') 
        for i in range(tot): 
            if arr1[i][1] > 0 and j < 3: 
                f3.write(lines[4*int(arr1[i][0])+2]) 
                f3.write(lines[4*int(arr1[i][0])+3]) 
                f3.write(lines[4*int(arr1[i][0])+4] + '\n') 
                j += 1
 
    else: 
        f3.write(str(count) + '\n\n') 
        for i in range(tot): 
            if arr1[i][1] > 0: 
                f3.write(lines[4*int(arr1[i][0])+2]) 
                f3.write(lines[4*int(arr1[i][0])+3]) 
                f3.write(lines[4*int(arr1[i][0])+4] + '\n')
